<?php
	if(!defined('ABSPATH')) die('No direct access!');

	$colsRowsOptions = array(
		'1-24' => '1 x 24',
		'2-12' => '2 x 12',
		'4-6' => '4 x 6',
		'5-5' => '5 x 5',
		'6-4' => '6 x 4',
		'7-4' => '7 x 4',
		'12-2' => '12 x 2',
		'24-1' => '24 x 1'
	);

	$a = json_decode(get_option('adventskalender'), true);
	$save=false;
	if(!isset($a)){
		$a = array();
		$save = true;
	}
	if(!isset($a['urls'])){
		$a['urls'] = array(
			'','','','','','',
			'','','','','','',
			'','','','','','',
			'','','','','',''
		); // 24 days
		$save = true;
	}
	if(!isset($a['ratio'])) {
		$a['ratio'] = "100"; //aspect ratio 1:1
		$save = true;
	}
	if(!isset($a['rows'])) {
		$a['rows'] = 24;
		$save = true;
	}
	if(!isset($a['cols'])) {
		$a['cols'] = 1;
		$save = true;
	}
	if(!isset($a['year'])) {
		$a['year'] = intval(strftime("%Y"));
		$save = true;
	}

	if(isset($_POST['adventskalender-url'])){
		$a['url'] = esc_url($_POST['adventskalender-url']);
		$save = true;
	}
	
	if(isset($_POST['adventskalender-ratio'])){
		$ratio = explode('x', $_POST['adventskalender-ratio']);
		if(isset($ratio[1])) { //image dimensions as width x height
			$ratio[0] = Max(1, intval($ratio[0]));
			$ratio[1] = Max(1, intval($ratio[1]));
		} else { //image aspect ratio
			$ratio[0] = Max(0.01, floatval($ratio[0]));
		}
		$a['ratio'] = strval((isset($ratio[1]) ? intval($ratio[1]) / intval($ratio[0]) : floatval($ratio[0])) * 100);
		$save = true;
	}
	
	if(isset($_POST['adventskalender-width'])){
		$a['width'] = Max(1, intval($_POST['adventskalender-width']));
		$save = true;
	}
	
	if(isset($_POST['adventskalender-cols-rows'])){
		if(array_key_exists(sanitize_text_field($_POST['adventskalender-cols-rows']), $colsRowsOptions)) {
			$colsRows = explode('-', sanitize_text_field($_POST['adventskalender-cols-rows']));
			$a['cols'] = $colsRows[0];
			$a['rows'] = $colsRows[1];
			$save = true;
		}
	}
	
	if(isset($_POST['adventskalender-today-color'])){
		$a['today-color'] = sanitize_text_field($_POST['adventskalender-today-color']);
		$save = true;
	}
	
	if(isset($_POST['adventskalender-date'])){
		$a['date'] = sanitize_text_field($_POST['adventskalender-date']);
		if($a['date'] == ''){
			unset($a['date']);
		}
		$save = true;
	}
	
	if(isset($_POST['adventskalender-year'])){
		$a['year'] = sanitize_text_field($_POST['adventskalender-year']);
		$save = true;
	}
	
	foreach($a['urls'] as $i => $u){
		if(isset($_POST['adventskalender-urls-'.$i])){
			$a['urls'][$i] = esc_url($_POST['adventskalender-urls-'.$i]);
			$save = true;
		}
	}
	
	if($save){
		update_option('adventskalender', json_encode($a));
	}
	
	$colsRows = strval($a['cols']) . "-" . strval($a['rows']);
	echo '<style>
	.wrap label{
		padding: 10px 0;
	}
	.wrap label, .wrap input, .wrap select{
		display: inline-block;
		min-width: 200px;
		width: 48%;
		vertical-align: middle;
	}
</style>
<div class="wrap">
	<h2>Adventskalender <a class="add-new-h2" href="'.menu_page_url('adventskalender_tutorial', false).'">Tutorial</a></h2>
	<form name="form1" method="post" action="" style="display: inline-block;">
		<hr/>
		<label for="adventskalender-code">Shortcode</label>
		<input id="adventskalender-code" type="text" value="[adventskalender]" readonly="readonly"/>
		<hr/>
		<label for="adventskalender-url">Bild<br/><sup>URL-Adresse</sup></label>
		<input id="adventskalender-url" name="adventskalender-url" type="url" value="'.$a['url'].'"/><br/>
		<label for="adventskalender-ratio">Bild<br/><sup>Seitenverh&auml;ltnis oder Aufl&ouml;sung</sup></label>
		<input id="adventskalender-ratio" name="adventskalender-ratio" type="text" value="'.strval(floatval($a['ratio'] / 100)).'"/><br/>
		<label for="adventskalender-cols-rows">Spalten / Zeilen<br/><sup>&Uuml;brige Felder sind leer (bei 5 x 5 und 7 x 4)</sup></label>
		<select id="adventskalender-cols-rows" name="adventskalender-cols-rows">';
		foreach($colsRowsOptions as $k => $v){ echo '
			<option value="'.$k.'"'.($colsRows == $k? ' selected="selected"' :'').'>'.$v.'</option>';}
		echo '
		</select><br/>
		<label for="adventskalender-width">Maximale Breite</label>
		<input id="adventskalender-width" name="adventskalender-width" type="number" value="'.$a['width'].'"/><br/>
		<label for="adventskalender-today-color">Farbe f&uuml;r den aktuellen Tag<br/><sup>
			#RRGGBB (Hexadezimaler Farbwert)<br/>
			<b>oder</b><br/>
			rgba(Rot, Gr&uuml;n, Blau, Deckkraft)<br/>
			&emsp;Rot, Gr&uuml;n, Blau:&emsp;0 - 255<br/>
			&emsp;Deckkraft:&emsp;0.0 - 1.0
		</sup></label>
		<input id="adventskalender-today-color" name="adventskalender-today-color" type="text" value="'.$a['today-color'].'"/><br/>
		<label for="adventskalender-date">Test Datum<br/><sup>F&uuml;r Tests, ansonsten leer</sup></label>
		<input id="adventskalender-date" name="adventskalender-date" type="date" value="'.$a['date'].'"/><br/>
		<label for="adventskalender-year">Jahr</label>
		<input id="adventskalender-year" name="adventskalender-year" type="number" value="'.$a['year'].'"/><br/>
		<hr/>
		<input type="submit" value="Speichern" class="button"/>
		<hr/>';
		foreach($a['urls'] as $i => $u){echo '
		<label for="adventskalender-urls-'.$i.'">Link f&uuml;r Tag '.($i+1).'</label>
		<input id="adventskalender-urls-'.$i.'" name="adventskalender-urls-'.$i.'" type="url" value="'.$a['urls'][$i].'"/><br/>';}
		echo '
		<hr/>
		<input type="submit" value="Speichern" class="button"/>
		<hr/>
	</form>
</div>';